import { Component } from '@angular/core'
import {LogMessage as NgxLogMessage} from 'ngx-log-monitor';
import { timer } from 'rxjs';
import { map, take } from 'rxjs/operators';
import { webSocket, WebSocketSubject } from 'rxjs/webSocket';
import { Observable } from 'rxjs';

@Component({
    selector : 'app-log-list',
    templateUrl : './log-list.component.html',
    styleUrls : ['./log-list.component.scss']
})

export class LogComponent {
    private socket$: WebSocketSubject<any>
    

      constructor (){

      }

    restoredLogs: NgxLogMessage[] = [
        {message: 'A simple restored log message'},
        {message: 'A success restored message', type: 'SUCCESS'},
        {message: 'A warning restored message', type: 'WARN'},
        {message: 'An error restored message', type: 'ERR'},
        {message: 'An info restored message', type: 'INFO'},
      ];
    
    logs: NgxLogMessage[] = [
        {message: 'A simple log message'},
        {message: 'A success message', type: 'SUCCESS'},
        {message: 'A warning message', type: 'WARN'},
        {message: 'An error message', type: 'ERR'},
        {message: 'An info message', type: 'INFO'},
      ]

      logStream$ = new Observable(subscriber => {
        // set ws protocol when using http and wss when using https
        const protocol = window.location.protocol.replace('http', 'ws');
        // get location host
        const host = window.location.host;

        webSocket(`${protocol}//${host}/ws/log`).subscribe(
        msg => subscriber.next(msg))
      })
      
    //logStream$ = timer(0, 1000).pipe(
    //    take(this.logs.length),
    //    map(i => this.logs[i])
    //)
    
}