import { Component, OnInit } from '@angular/core'
import { Router, ActivatedRoute, Params } from '@angular/router'
import { FileService } from '../file.service'

@Component({
  selector: 'App-Fileview',
  templateUrl: './file-view.component.html',
  styleUrls: ['./file-view.component.scss']
})

export class FileViewComponent {

    constructor(public fileService: FileService, private activatedRoute: ActivatedRoute, private router: Router) {}
    public sha256: string;
    public hasBeenAnalyzed = false
    dataSource
    public isanalyzing = false
    
    ngOnInit() {
       // Note: Below 'queryParams' can be replaced with 'params' depending on your requirements
       // Sets the URL to the sha256 to make the site more dynamic and that every file has its own page
       this.sha256 = this.activatedRoute.snapshot.paramMap.get('sha256')                              
       this.fileService.getFile(this.sha256)
            .subscribe((data) => {
                this.dataSource = data
                if(this.dataSource.pending_analysis.virustotal || this.dataSource.pending_analysis.peframe) {
                    this.isanalyzing = true
                }
                if(this.dataSource.analyzed_info){
                    this.hasBeenAnalyzed = true
                }
        }, error => {
            console.log(error)
            this.router.navigate(['/404'])
        })
    }
}
