import { Component, OnDestroy, OnInit } from "@angular/core";
import { Subscription } from "rxjs";
import { AuthService } from "../auth/auth.service";

@Component({
    selector: 'app-header',
    templateUrl: './header.component.html',
    styleUrls: ['./header.component.scss']

})

export class HeaderComponent implements OnInit, OnDestroy{ 
    userIsAuthenticated = false //False by default, user should not be authenticated before logging in = false //False by default, user should not be authenticated before logging in
    private authListnerSubs: Subscription 
    userRole : string
    user

    constructor(private AuthService: AuthService) {}

        ngOnInit() { //Show header items to authenticated users
            this.authListnerSubs = this.AuthService.getAuthStatusListener()
                .subscribe(isAuthenticated => {
                    this.userIsAuthenticated = isAuthenticated  //Authorizes user
                }) 
            this.user = this.AuthService.user
        }

        onLogout() { //Adds logout functionality, linked to a auth.service.js signout()
            this.AuthService.signout()
        }


        ngOnDestroy() { //Un-authorizes user
            this.authListnerSubs.unsubscribe() 
        }
}