#!/usr/bin/python3

from zipfile import ZipFile
from tarfile import TarFile
from pyunpack import Archive
import sys
import gzip
import magic
import os

outfolder=''


def main(folder, file):
    filepath = "docker/" + folder + "/" + file
    global outfolder
    outfolder = "decompressed/" + folder

    filetype = findFileType(filepath)
    if filetype == "application/zip":
        openZip(filepath)
    elif filetype == "application/x-rar":
        pre = os.path.splitext(filepath)[0]
        os.rename(filepath, pre + ".rar")
        openRar(pre + ".rar")
    elif filetype == "application/x-tar":
        openGzip(filepath)
    elif filetype == "application/gzip":
        openGzip(filepath, "r:gz")
    else:
        print("no archiving found")
        os.rename(filepath, outfolder + "/" + os.path.basename(file))


def findFileType(file):
    filetype = magic.from_file(file, mime=True)
    print(filetype)
    return filetype

def openZip(file):
    print("unzipping file")
    zipped = ZipFile(file)
    for zinfo in zipped.infolist():
        is_encrypted = zinfo.flag_bits & 0x1 
    if is_encrypted:
        print ('%s is encrypted!' % zinfo.filename)
        if not bruteZip(file):
            print('Not able to bruteforce file')

    else:
        try:
            zipped.extractall(outfolder)
            os.remove(file)
        except:
            pass

def bruteZip(file):
    unzipped = False
    print("bruteforcing zip")
    wordlist = open("../wordlist.txt", "r", encoding="latin-1")
    zipped = ZipFile(file)
    for line in wordlist:
        try:
            line = line.rstrip().encode()
            zipped.extractall(path=outfolder, pwd=line)
            os.remove(file)
            unzipped = True
        except Exception as e:
            print('Bruteforce error:', e)
    if unzipped:
        return True
    else:
        return False


def openRar(file):
    print("unraring file")
    try:
        Archive(file).extractall(outfolder)
        os.remove(file)
    except:
        pass


def openGzip(file, type = "r"):
    #may be tar.gz
    print("untarring file")
    try:
        tarred = TarFile.open(file, type)
        tarred.extractall(outfolder)
        os.remove(file)
    except:
        print("gunzipping file")
        pre = os.path.splitext(file)[0]
        os.rename(file, pre)
        input = gzip.GzipFile(pre, 'rb')
        output = open(outfolder+ "/" + os.path.basename(pre), 'wb')
        s = input.read()
        input.close()

        output.write(s)
        output.close()
        os.remove(pre)






if __name__ == "__main__":
    main(sys.argv[1], sys.argv[2])