const winston = require('winston');
require('winston-daily-rotate-file')

var infoTransport = new winston.transports.DailyRotateFile({

    //Specify information about the logfiles including where to store them
    name: 'infologger',
    level: 'info',
    filename: 'info-%DATE%.log',
    dirname: 'logging/infologs',
    datePattern: 'YYYY-MM-DD',
    zippedArchive: true,
    maxSize: '20m',
    maxFiles: '14d'
});

const infologger = winston.createLogger({
    //Formatting the log-message
    format: winston.format.combine(winston.format.timestamp(), winston.format.json()),
    
    //Where to ship the logs
    transports: [
        //To the console
        //new winston.transports.Console(),
        //To the userTransport defined at line 4
        infoTransport
    ]
})

//Export the logger
module.exports = infologger;